<?php

   $p = $_GET['p'];
   
   if ($p == "srv2")
      getServers();
   if ($p == "news")
      getNews();
   if ($p == "active")
      getActiveTopics();
      
   function getServers()
   {
      $data = getPage("http://www.ut-slv.com/universalunreal/");
      
      preg_match_all("/<b>(.*)<\/b> \(<a href=\"(unreal:\/\/.*)\".*<\/a>\)<br>((.*)\(<a.*id=(.*)\">(.*)<\/a>\)|(No Data))/U", $data, $Matches);
      
      for ($i = 0;$i < count($Matches[1]);$i++)
      {
         $Rank[$i] = $i + 1;
         $Name[$i] = $Matches[1][$i];
         $Server[$i] = $Matches[2][$i];
         $Map[$i] = ($Matches[4][$i] == "" ? $Matches[7][$i] : $Matches[4][$i]);
         $PlayerCount[$i] = ($Matches[7][$i] != "" ? "Down?" : $Matches[6][$i]);
         $Players[$i] = ($Matches[5][$i] == "" ? "" : getPlayersById($Matches[5][$i]));
      }
      
      for ($i = 0;$i < 10;$i++)
      {
         if ($Rank[$i])
            echo htmlspecialchars_decode("<rank>". $Rank[$i] ."</rank><info>". $Name[$i] .": ". $Map[$i] ."(". $PlayerCount[$i] .")</info><server>". $Server[$i] ."</server><players>". $Players[$i] ."</players>");
         else
            echo "<rank></rank><info></info><server></server><players></players>";
      }
   }
   
   function getPlayersById($id)
   {
      $data = getPage("http://www.ut-slv.com/universalunreal/index.php?p=players&id=". $id);
      
      preg_match_all("/<td><p align=\"center\"><b>(.*)<\/b>/U", $data, $Players);
      $Players = $Players[1];
      
      for ($i = 0;$i < count($Players);$i++)
         $names .= $Players[$i] ." ";
         
      return $names;
   }

   function getActiveTopics()
   {
      $data = getPage("http://www.ut-slv.com/forum/search.php?search_id=active_topics");
      
      preg_match_all("/class=\"topictitle\">(.*)<\/a>/U", $data, $Topics);
      $Topics = $Topics[1];
      
      preg_match_all("/<p class=\"topicauthor\"><a.+?>(.*)<\/a>/U", $data, $Names);
      $Names = $Names[1];
      
      preg_match_all("/<a href=\"\.\/(.*)\" class=\"topictitle\">/U", $data, $Urls);
      $Urls = $Urls[1];
      
      for ($i = 0;$i < 10;$i++)
         echo htmlspecialchars_decode("<topic>". $Topics[$i] ."</topic><link>". ($Urls[$i] != "" ? "http://www.ut-slv.com/forum/" : ""). $Urls[$i] ."</link><poster>". $Names[$i] ."</poster>");
   }
      
   function getNews()
   {
      $data = getPage("www.ut-slv.com/forum/");
      
      preg_match_all("/<strong>(.*)<\/strong><\/a><\/td>/", $data, $Topics);
      $Topics = $Topics[1];
      
      preg_match_all("/&raquo;(.* [a|p]m)/U", $data, $Dates);
      $Dates = $Dates[1];
      
      preg_match_all("/Posted by.*class=\"username-coloured\">(.*)<\/a>/U", $data, $Names);
      $Names = $Names[1];
      
      preg_match_all("/latest post.*<a.*(viewtopic\.php\?f=247.+?)\"><strong>/U", $data, $Urls);
      $Urls = $Urls[1];

      for ($i = 0;$i < 10;$i++)
         echo htmlspecialchars_decode("<topic>". $Topics[$i] ."</topic><date>". $Dates[$i] ."</date><poster>". $Names[$i] ."</poster><link>". ($Urls[$i] != "" ? "http://www.ut-slv.com/forum/" : ""). $Urls[$i] ."</link>");
   }
   
   function getPage($page)
   {
      $sp = curl_init();
      
      curl_setopt($sp, CURLOPT_URL, $page);
      curl_setopt($sp, CURLOPT_RETURNTRANSFER, 1);
      
      $data = curl_exec($sp);
      curl_close($sp);
      
      return $data;
   }
?>